<?php

class DAO {
	
//	private $dbConnection = null;
//	private $daoFactory = null;
	
	const SORT_ASCENDING = 'ASC';
	const SORT_DESCENDING = 'DESC';

	function DAO() {
	}

	//parse by reference so we only have one connection object
//	public function setDBConnection( &$dbConnection) {
//		$this->dbConnection = $dbConnection;
//	}	


	protected function connection() {
		
		global $dbConnection;
		
		if( !$dbConnection->IsConnected() ) {
			//Logger::Log('connection gone: reconnecting:');
			//$this->dbConnection = DAOFactory::getDatabaseConnection('database');
			echo 'db is not connected'; 
		}
		
		return $dbConnection;
	}

/*
	//so a dao can access other daos.
	public function setDAOFactory( $daoFactory) {
		$this->daoFactory = $daoFactory;
	}
*/
	
	/*	
	public function getDAOByName( $daoName) {
		return $this->daoFactory->getDAOByName( $daoName);
	}*/

/*
	protected function &dbConnection() {
		
		global $dbConnection;

		if( !$dbConnection->IsConnected() ) {
//		if( !$this->dbConnection->IsConnected() ) {
			Logger::Log('connection gone: closing...');
			$dbConnection->close();
			Logger::Log('connection gone: reconnecting...');
			DAOFactory::getDatabaseConnection('database'); 
			//$dbConnection = DAOFactory::getDatabaseConnection('database'); 
		}
		
		return $dbConnection;
	}
*/	

	public function recordCountForValue( $tableName, $column, $value) {

 		$statement = $this->connection()->Prepare( "SELECT count(*) count FROM $tableName WHERE $column = ?");
		$resultSet = $this->executePreparedStatement( $statement, array( $value));
		if( false == $resultSet->fields)
		{
			return 0;
		}
		return $resultSet->fields['count'];
	}

	public function executePreparedStatement( $preparedStatement, $dataArray) {
		
		$resultSet = $this->connection()->Execute( $preparedStatement, $dataArray);
		return $resultSet;
	}
	
	public function getFieldValueForId( $tableName, $fieldName, $rowId) {

 		$statement = $this->connection()->Prepare("SELECT $fieldName FROM $tableName WHERE id = ?");
		$resultSet = $this->executePreparedStatement( $statement, array( $rowId));
		if( false == $resultSet->fields)
		{
			throw new Exception( "row not found with id: $rowId.");
		}
		return $resultSet->fields[ $fieldName];
	}

	//returns false if not found, does not throw an exception
	public function getFieldValueForField( $tableName, $selectField, $whereField, $fieldValue) {

 		$statement = $this->connection()->Prepare("SELECT $selectField FROM $tableName WHERE $whereField = ?");
		$resultSet = $this->executePreparedStatement( $statement, array( $fieldValue));
		if( false == $resultSet->fields)
		{
			return false;
			//throw new Exception( "row not found with column: $whereField.");
		}
		return $resultSet->fields[ $selectField];
	}

	public function getCountOf( $tableName) {

		//POINTLESS PREPARED STATEMENT???
 		$statement = $this->connection()->Prepare("SELECT count(*) count FROM $tableName");
		$resultSet = $this->executePreparedStatement( $statement, array());
		if( false == $resultSet->fields) {
			return 0;	//there are 0 users.
		}
		return $resultSet->fields['count'];		
	}

	public function getTableRowCountForColumn( $tableName, $columnName, $columnValue) {

 		$statement = $this->connection()->Prepare("SELECT count(*) count FROM $tableName WHERE ? = ?");
		$resultSet = $this->executePreparedStatement( $statement, array( $columnName, $columnValue));

		if( false == $resultSet->fields) {
			return 0;	//there are 0 users.
		}

		return $resultSet->fields['count'];		
	}

	public function executeScript( $scriptName, $tokens = null, $replacements = null) {
		
		$everythingOk = true;
		$this->connection()->BeginTrans();
		
		$handle = @fopen( $scriptName, "r");
		if( $handle) {
			
			$statementIsComplete = false;
			$finalStatement = '';
		    while( !feof( $handle) ) {
		        $sqlStatement = trim( fgets( $handle, 4096) );
		        //echo "\n$sqlStatement\n";
		        if( $sqlStatement != null && $sqlStatement != "" && substr( $sqlStatement, 0, 2 ) != '--') {
		        	
		        	$lineLength = strlen( $sqlStatement);
		        	$lastLineCharacter = substr($sqlStatement, $lineLength - 1, 1);
		        	
	        		$finalStatement .= $sqlStatement;
		        	
		        	if( $lastLineCharacter == ';') {

						//remove line breaks etc:
						$order = array("\r\n", "\n", "\r");
						$finalStatement = str_replace($order, '', $finalStatement);						

						if( isset( $tokens) && isset( $replacements) ) {
							//replace an array of tokens with an array of replacement values
							$finalStatement = str_replace( $tokens, $replacements, $finalStatement);
						}

						//echo "\n$finalStatement\n";

						$result = $this->executePreparedStatement( $finalStatement, array() );
						
						if( !$result) {
							$everythingOk = false;						
							echo "error executing statement: $finalStatement";
							break;
						}
						$finalStatement = '';
						
		        	} else {
		        	}
		        	
		        }
		    }
		    fclose( $handle);
		}
		
		if( $everythingOk) {
			$this->connection()->CommitTrans();
		} else {
			$this->connection()->RollbackTrans();	
		}		
		
	}

	public static function arrayToInClause( $itemsArray) {
		
		if( is_array( $itemsArray) ) {
			
			foreach( $itemsArray as $key => $value) {
				$itemsArray[ $key] = "'" . $value . "'";
			}
			$result = '(' . implode(',', $itemsArray) . ')';
		} else {
			$result = "('$itemsArray')";
		}
		return $result;
	}
	
}
?>